import { Table } from './table';
import { DatabaseConnector } from './database/database-connector-builder';
export interface Schema {
    maxCharLength: number;
    minDate: string;
    ignoredTables: string[];
    tables: Table[];
    values: {
        [key: string]: any[];
    };
}
export declare type TableWithForeignKeys = Table & {
    referencedTables: string[];
};
export declare const dummyCustomSchema: Schema;
export declare class Analyser {
    private dbConnector;
    private customSchema;
    constructor(dbConnector: DatabaseConnector, customSchema: Schema);
    analyse(): Promise<Schema>;
    private customizeTable;
    private extractColumns;
    private extractForeignKeys;
    private orderTablesByForeignKeys;
    private generateJson;
}
