import { TableWithForeignKeys } from '../analyser';
import { DatabaseConnector } from './database-connector-builder';
import { Table } from '../table';
export declare class MariaDBConnector implements DatabaseConnector {
    private database;
    private dbConnection;
    constructor(ip: string, port: number, database: string, user: string, password: string);
    getTablesInformation(ignoredTables: string[]): Promise<TableWithForeignKeys[]>;
    getColumnsInformation(table: Table): Promise<any[] | any[]>;
    getForeignKeys(table: Table): Promise<any[]>;
    countLines(table: Table): Promise<number>;
    emptyTable(table: Table): Promise<void>;
    getValuesForForeignKeys(table: string, column: string, foreignTable: string, foreignColumn: string, limit: number, unique: boolean, condition: string): Promise<any[]>;
    executeRawQuery(query: string): Promise<void>;
    insert(table: string, rows: any[]): Promise<number>;
    destroy(): Promise<void>;
}
