import { Column } from './column';
import { DatabaseConnector } from './database/database-connector-builder';
declare type RequireAtLeastOne<T, Keys extends keyof T = keyof T> = Pick<T, Exclude<keyof T, Keys>> & {
    [K in Keys]-?: Required<Pick<T, K>> & Partial<Pick<T, Exclude<Keys, K>>>;
}[Keys];
interface BaseTable {
    name: string;
    /** @deprecated: This parameter has been renamed maxLines */
    lines?: number;
    columns: Column[];
    before?: string[];
    after?: string[];
    maxLines?: number;
    addLines?: number;
}
export declare type Table = RequireAtLeastOne<BaseTable, 'maxLines' | 'addLines'>;
export declare class TableService {
    private dbConnector;
    private maxCharLength;
    private values;
    constructor(dbConnector: DatabaseConnector, maxCharLength: number, values: {
        [key: string]: any[];
    });
    private empty;
    private getForeignKeyValues;
    fill(table: Table, reset: boolean): Promise<void>;
    private before;
    private generateData;
    private after;
}
export {};
